﻿using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AdTech.Snap.Test
{
    /// <summary>
    /// This is a test class for various viewmodels and their ICommands and is intended
    /// to contain all ICommand.CanExecute Unit Tests
    /// </summary>
    [TestClass()]
    public class CanExecuteCommandTest
    {
        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        /// A test for ConfigViewModel
        /// </summary>
        [TestMethod()]
        public void ConfigViewModel()
        {
            IConfiguration cfg = DefaultConfiguration.Create();
            ConfigViewModel vm = new ConfigViewModel(cfg, null);
            Assert.IsFalse(vm.SaveCommand.CanExecute(null));
            vm.UseDropbox = true;
            Assert.IsFalse(vm.SaveCommand.CanExecute(null));
            vm.DefaultFileDestination = System.Environment.CurrentDirectory;
            Assert.IsTrue(vm.SaveCommand.CanExecute(null));
        }
    }
}
