﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AdTech.Snap.Test
{
    /// <summary>
    /// This is a test class for ConfigViewModelTest and is intended
    /// to contain all ConfigViewModelTest Unit Tests
    /// </summary>
    [TestClass()]
    public class ConfigViewModelTest
    {
        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        /// A test for ConfigViewModel
        /// </summary>
        [TestMethod()]
        public void ConfigViewModelPropertyTest()
        {
            IConfiguration configModel = DefaultConfiguration.Default();
            configModel.UseDropbox = true;
            configModel.DefaultFileDestination = Environment.CurrentDirectory;
            configModel.DropboxUID = 666;
            IDropboxFactory dropboxFactory = null;
            ConfigViewModel target = new ConfigViewModel(configModel, dropboxFactory);
            Assert.IsFalse(configModel.IsNew);
            Assert.AreEqual(configModel.DefaultFileDestination, target.DefaultFileDestination);
            Assert.AreEqual(configModel.DropboxUID, target.DropboxUID);
            Assert.AreEqual(configModel.OverlayColor, target.OverlayColor);
            Assert.AreEqual(configModel.OverlayColorOpacity, target.OverlayColorOpacity);
            Assert.AreEqual(configModel.UseDropbox, target.UseDropbox);
        }
    }
}
