﻿using System.Windows;
using AdTech.Snap.Interop;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AdTech.Snap.Test
{
    /// <summary>
    /// This is a test class for MonitorInteropHelperTest and is intended
    /// to contain all MonitorInteropHelper Unit Tests
    /// </summary>
    [TestClass()]
    public class MonitorInteropHelperTest
    {
        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        /// A test for GetFullScreenBoundaries
        /// </summary>
        [TestMethod()]
        public void GetFullScreenBoundariesTest()
        {
            Rect leftMonitor = new Rect(-1680, 0, 1680, 1050);
            Rect primMonitor = new Rect(new Size(1680,1050));
            leftMonitor.Union(primMonitor);
            Rect boundaries = MonitorInteropHelper.GetTotalScreenBoundaries();
            Assert.AreEqual(leftMonitor, boundaries);
        }
    }
}
