﻿using System.Windows.Controls;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;

namespace AdTech.Snap.Test
{
    /// <summary>
    /// This is a test class for QRCodeTest and is intended
    /// to contain all QRCode Unit Tests
    /// </summary>
    [TestClass()]
    public class QRCodeTest
    {
        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        /// A test for QRCodeFactory
        /// </summary>
        [TestMethod()]
        public void QRCodeFactoryTest()
        {
            IQRCodeFactory factory = QRCodeFactory.Create();
            QRCode obj = new QRCode { Content = "QRCodeFactoryTest" };
            byte[] qrcodeImg = factory.Encode(obj);
            string result;
            using (MemoryStream ms = new MemoryStream(qrcodeImg))
            {
                result = factory.Decode(ms).Content;
            }
            Assert.AreEqual(obj.Content, result);
        }
    }
}
